import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;

/**
 * @author bachmaer
 *         <p/>
 *         Obstacle server.
 */
public class SpaceGameServer {
    // Array of obstacle positions
    int[][] obstacleData = {
            {Constants.MAX_SECTOR_X / 2, Constants.MAX_SECTOR_Y / 2},
            {Constants.MAX_SECTOR_X / 4, Constants.MAX_SECTOR_Y / 4},
            {Constants.MAX_SECTOR_X / 4 + Constants.INCREMENT, Constants.MAX_SECTOR_Y / 4},
            {Constants.MAX_SECTOR_X / 4 + Constants.INCREMENT, Constants.MAX_SECTOR_Y / 4},
            {Constants.MAX_SECTOR_X / 4 + Constants.INCREMENT, Constants.MAX_SECTOR_Y / 4},
            {3 * Constants.MAX_SECTOR_X / 4, 3 * Constants.MAX_SECTOR_Y / 4},
            {3 * Constants.MAX_SECTOR_X / 4, 3 * Constants.MAX_SECTOR_Y / 4 + Constants.INCREMENT},
            {3 * Constants.MAX_SECTOR_X / 4, 3 * Constants.MAX_SECTOR_Y / 4 + Constants.INCREMENT},
            {3 * Constants.MAX_SECTOR_X / 4, 3 * Constants.MAX_SECTOR_Y / 4 + Constants.INCREMENT}};

    // Default obstacle server port
    static final int SERVER_PORT = 4444;

    /**
     * Contains a infinite loop that used to alternately multicasts location
     * messages and listens for clients. A separate thread is spawned to
     * communicate with each client
     */
    public SpaceGameServer() {
        try {
            new ClientHandler().start();
            ServerSocket ss = new ServerSocket(SERVER_PORT);
            while (true) {
                Socket clientSocket = ss.accept();
                System.out.println("Sending obstacles to "+clientSocket.getInetAddress());
                DataOutputStream dos = new DataOutputStream(clientSocket.getOutputStream());
                dos.writeInt(obstacleData[3][0]);
                dos.writeInt(obstacleData[3][1]);
                dos.writeInt(obstacleData[1][0]);
                dos.writeInt(obstacleData[1][1]);
                dos.writeInt(obstacleData[6][0]);
                dos.writeInt(obstacleData[6][1]);
                dos.writeInt(-1);
                dos.close();
                clientSocket.close();
            }
        } catch (IOException e) {
            System.out.println("Accept failed: " + SERVER_PORT);
            System.exit(-1);
        }

    } // end ObstacleServer constructor


    /**
     * Driver for starting the server.
     *
     * @param args
     */
    public static void main(String[] args) {
        new SpaceGameServer();

    } // end main


} // end ObstacleServer class

