import java.awt.*;
import java.awt.event.*;

/*
 * Created on Nov 17, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author bachmaer
 *         <p/>
 *         Capture events and displays view of current sector
 */
public class SpaceGui extends Frame {
    // The components of the the GUI.
    private Button rtTurn = new Button("Turn Right");
    private Button lfTurn = new Button("Turn Left");
    private Button move = new Button("Move");
    private Button join = new Button("Join");
    private Button quit = new Button("Quit");

    SpaceGame game = null;

    Sector sector = null;

    public SpaceGui(SpaceGame g, Sector s) {

        super("Space War");

        game = g;
        sector = s;

        // Create panels for holding the fields. To make it look nice,
        // create an extra panel for holding all the child panels.
        Panel controlPanel = new Panel(new GridLayout(0, 1));
        controlPanel.add(move);
        controlPanel.add(lfTurn);
        controlPanel.add(rtTurn);
        controlPanel.add(join);
        controlPanel.add(quit);

        move.addActionListener(new moveListener());
        lfTurn.addActionListener(new lfTurnListener());
        rtTurn.addActionListener(new rtTurnListener());
        join.addActionListener(new joinListener());
        quit.addActionListener(new QuitListener());

        add(sector, BorderLayout.CENTER);

        add("East", controlPanel);

        addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }

        });

        setSize(600, 600);

        this.setResizable(false);

        setVisible(true);

    } // end default constructor


    // Inner class Handler for the right turn event
    class rtTurnListener implements ActionListener {


        public void actionPerformed(ActionEvent event) {
            game.turnRight();

        } // end actionPerformed


    } // end rtTurnListener class

    // Inner class Handler for the right turn event
    class lfTurnListener implements ActionListener {

        public void actionPerformed(ActionEvent event) {
            game.turnLeft();

        } // end actionPerformed


    } // end rtTurnListener class

    // Inner class Handler for the right turn event
    class moveListener implements ActionListener {

        public void actionPerformed(ActionEvent event) {
            game.moveFoward();

        } // end actionPerformed


    } // end moveListener class


    // Inner class Handler for the join event
    class joinListener implements ActionListener {

        public void actionPerformed(ActionEvent event) {
            game.join();


        } // end actionPerformed


    } // end joinListener class


    // Inner class to handle Quit button events
    class QuitListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            System.out.println("Quitting...");
            game.sender.remove(SpaceGame.sector.ownShip);
            System.exit(0);
        } // end actionPerformed

    } // end QuitListener class

}
