import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: mopar
 * Date: Jan 30, 2007
 * Time: 12:21:11 AM
 * To change this template use File | Settings | File Templates.
 */
public class UDPReciever extends Thread {

    DatagramSocket dgSock;

    public static final int JOIN_CODE = 0;
    public static final int UPDATE_CODE = 1;
    public static final int REMOVE_CODE = 2;

    public UDPReciever(DatagramSocket dgSock) {
        super("UDPReciever");
        this.dgSock = dgSock;
    }

    public void run() {
        while (true) {
            try {
                byte[] bytes = new byte[256];
                DatagramPacket rePacket = new DatagramPacket(bytes,
                        bytes.length);
                dgSock.receive(rePacket);
                System.out.println("Packet Recieved from: "
                        + rePacket.getSocketAddress());
                ByteArrayInputStream bis = new ByteArrayInputStream(rePacket.getData());
                DataInputStream dis = new DataInputStream(bis);
                switch (dis.readInt()) {
                    case JOIN_CODE:
                        joinOrUpdate(dis);
                        break;
                    case UPDATE_CODE:
                        joinOrUpdate(dis);
                        break;
                    case REMOVE_CODE:
                        remove(dis);
                        break;
                    default:
                        System.out.println("Malformed Packet");
                        break;
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private AlienSpaceCraft getSpaceCraft(DataInputStream dis) throws IOException {
        int x = dis.readInt();
        int y = dis.readInt();
        int heading = dis.readInt();
        byte[] ipBytes = new byte[4];
        if (dis.read(ipBytes) == -1)
            throw new IOException("Malformed Packet");
        InetAddress ia = InetAddress.getByAddress(ipBytes);
        int port = dis.readInt();
        return new AlienSpaceCraft(ia, port, x, y, heading);
    }

    public void joinOrUpdate(DataInputStream dis) throws IOException {
        SpaceGame.sector.updateAndAddSpaceCraft(getSpaceCraft(dis));
    }

    public void remove(DataInputStream dis) throws IOException {
        SpaceGame.sector.removeSpaceCraft(getSpaceCraft(dis));
    }
}
