import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.io.DataOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: mopar
 * Date: Jan 29, 2007
 * Time: 11:17:55 PM
 * To change this template use File | Settings | File Templates.
 */
public class UDPSender {

    private DatagramSocket dgSock;
    private InetAddress server;
    private int serverPort;

    private int JOIN_CODE = 0;
    private int UPDATE_CODE = 1;
    private int REMOVE_CODE = 2;


    public UDPSender(DatagramSocket dgSock, InetAddress server, int serverPort) {
        this.dgSock = dgSock;
        this.server = server;
        this.serverPort = serverPort;
    }

    private void send(byte[] data) {
        DatagramPacket packet = new DatagramPacket(data, data.length, server, serverPort);
        try {
            dgSock.send(packet);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void addIPPort(DataOutputStream dos) throws IOException {
        dos.write(SpaceGame.sector.ownShip.ID.getAddress());
        dos.writeInt(SpaceGame.sector.ownShip.IDport);
    }

    public void update() {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        try {
            dos.writeInt(UPDATE_CODE);
            dos.writeInt(SpaceGame.sector.ownShip.getXPosition());
            dos.writeInt(SpaceGame.sector.ownShip.getYPosition());
            dos.writeInt(SpaceGame.sector.ownShip.getHeading());
            addIPPort(dos);
            send(bos.toByteArray());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void join() {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        try {
            dos.writeInt(JOIN_CODE);
            dos.writeInt(SpaceGame.sector.ownShip.getXPosition());
            dos.writeInt(SpaceGame.sector.ownShip.getYPosition());
            dos.writeInt(SpaceGame.sector.ownShip.getHeading());
            addIPPort(dos);
            send(bos.toByteArray());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void remove(SpaceCraft target) {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        try {
            dos.writeInt(REMOVE_CODE);
            dos.writeInt(target.getXPosition());
            dos.writeInt(target.getYPosition());
            dos.writeInt(target.getHeading());
            dos.write(target.ID.getAddress());
            dos.writeInt(target.IDport);
            send(bos.toByteArray());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
